$(function(){
function showMenu() {
slideOut.option("menuVisible", !slideOut.option("menuVisible"));
}
var slideOut = $("#slideout").dxSlideOut({
dataSource: products,
onItemClick: showMenu,
menuVisible: true,
swipeEnabled: true,
menuGrouped: true,
itemTemplate: function(itemData, itemIndex, itemElement) {
$("<div/>")
.appendTo(itemElement)
.dxToolbar({
dataSource: [{
location: "before",
widget: "dxButton",
options: {
icon: "menu",
onClick: showMenu
}
}, {
location: "center",
template: function(e) {
return "<p>" + itemData.text + "</p>";
}
}]
});
var $infoContainer = $("<div />").attr("id", "info");
$infoContainer.append(
$("<img />").attr("src", itemData.src),
$("<h1 />").text(itemData.price)
);
var $fieldSetContainer = $("<div />").addClass("dx-fieldset");
$fieldSetContainer.append(
$("<div />").addClass("dx-fieldset-header").text("Options"),
$("<div />").addClass("dx-field").append(
$("<div />").addClass("dx-field-label").text("Swipe to reveal the menu"),
$("<div />").addClass("dx-field-value switch")
)
);
itemElement.append($infoContainer, $fieldSetContainer);
$(".switch").dxSwitch({
value: slideOut ? slideOut.option("swipeEnabled") : true,
onValueChanged: function(e) {
slideOut.option("swipeEnabled", e.value);
}
});
},
menuGroupTemplate: function(e) {
return "<b>" + e.key + "</b>";
}
}).dxSlideOut("instance");
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="slideout-container">
<div id="slideout"></div>
</div>
</div>
</body>
</html>
p {
margin: 0;
}
#info {
width: 200px;
height: 200px;
text-align: center;
margin: 0 auto;
margin-top: 10px;
}
#info img {
width: 100%;
}
.slideout-container {
height: auto;
position: absolute;
top: 0;
bottom: 0;
width:100%;
}
.dx-field-label {
width: 70%;
}
var products = [{
key: "Televisions",
items: [
{ text: "SuperLCD 42", price: "$1200", src: "../../../../images/products/7.png" },
{ text: "SuperLED 42", price: "$1450", src: "../../../../images/products/5.png" },
{ text: "SuperLED 50", price: "$1600", src: "../../../../images/products/4.png" },
{ text: "SuperLCD 55", price: "$1350", src: "../../../../images/products/6.png" },
{ text: "SuperLCD 70", price: "$4000", src: "../../../../images/products/9.png" }
]
},
{
key: "Monitors",
items: [
{ text: "DesktopLCD 19", price: "$160", src: "../../../../images/products/10.png" },
{ text: "DesktopLCD 21", price: "$170", src: "../../../../images/products/12.png" },
{ text: "DesktopLED 21", price: "$180", src: "../../../../images/products/13.png" }
]
},
{
key: "Projectors",
items: [
{ text: "Projector Plus", price: "$550", src: "../../../../images/products/14.png" },
{ text: "Projector PlusHD", price: "$750", src: "../../../../images/products/15.png" }
]
},
{
key: "Video Players",
items: [
{ text: "HD Video Player", price: "$220", src: "../../../../images/products/1.png" },
{ text: "SuperHD Video Player", price: "$270", src: "../../../../images/products/2.png" }
]
}
];

<div class="slideout-container">
<dx-slide-out
#slideout
[dataSource]="dataSource"
(onItemClick)="menuVisible = !menuVisible;"
[menuGrouped]="true"
[(menuVisible)]="menuVisible"
[swipeEnabled]="true"
>
<div *dxTemplate="let product of 'item'">
<dx-toolbar [dataSource]="toolbarItems">
<div *dxTemplate="let data of 'title'">
<p>{{product.text}}</p>
</div>
</dx-toolbar>
<div id="info">
<img src="{{product.src}}">
<h1>{{product.price}}</h1>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Options</div>
<div class="dx-field">
<div class="dx-field-label">Swipe to reveal the menu</div>
<dx-switch class="dx-field-value" [(value)]="slideout.swipeEnabled">
</dx-switch>
</div>
</div>
</div>
<div *dxTemplate="let category of 'menuGroup'">
<b>{{category.key}}</b>
</div>
</dx-slide-out>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxSlideOutModule, DxToolbarModule, DxSwitchModule, DxTemplateModule } from 'devextreme-angular';
import { Category, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
preserveWhitespaces: true
})
export class AppComponent {
dataSource: Category[];
menuVisible: boolean;
toolbarItems: any[];
constructor(service: Service) {
this.menuVisible = true;
this.toolbarItems = [
{
location: 'before',
widget: 'dxButton',
options: {
icon: 'menu',
onClick: () => {
this.menuVisible = !this.menuVisible;
}
}
}, {
location: 'center',
template: 'title'
}
];
this.dataSource = service.getProducts();
}
}
@NgModule({
imports: [
BrowserModule,
DxSlideOutModule,
DxToolbarModule,
DxSwitchModule,
DxTemplateModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep p {
margin: 0;
}
::ng-deep #info {
width: 200px;
height: 200px;
text-align: center;
margin: 0 auto;
margin-top: 10px;
}
::ng-deep #info img {
width: 100%;
}
::ng-deep .slideout-container {
height: auto;
position: absolute;
top: 0;
bottom: 0;
width:100%;
}
::ng-deep .dx-field-label {
width: 70%;
}
import { Injectable } from '@angular/core';
export class Product {
text: string;
price: string;
src: string;
}
export class Category {
key: string;
items: Product[];
}
let data: Category[] = [
{
key: "Televisions",
items: [
{ text: "SuperLCD 42", price: "$1200", src: "../../../../images/products/7.png" },
{ text: "SuperLED 42", price: "$1450", src: "../../../../images/products/5.png" },
{ text: "SuperLED 50", price: "$1600", src: "../../../../images/products/4.png" },
{ text: "SuperLCD 55", price: "$1350", src: "../../../../images/products/6.png" },
{ text: "SuperLCD 70", price: "$4000", src: "../../../../images/products/9.png" }
]
}, {
key: "Monitors",
items: [
{ text: "DesktopLCD 19", price: "$160", src: "../../../../images/products/10.png" },
{ text: "DesktopLCD 21", price: "$170", src: "../../../../images/products/12.png" },
{ text: "DesktopLED 21", price: "$180", src: "../../../../images/products/13.png" }
]
}, {
key: "Projectors",
items: [
{ text: "Projector Plus", price: "$550", src: "../../../../images/products/14.png" },
{ text: "Projector PlusHD", price: "$750", src: "../../../../images/products/15.png" }
]
}, {
key: "Video Players",
items: [
{ text: "HD Video Player", price: "$220", src: "../../../../images/products/1.png" },
{ text: "SuperHD Video Player", price: "$270", src: "../../../../images/products/2.png" }
]
}
];
@Injectable()
export class Service {
getProducts(): Category[] {
return data;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.0.3/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8',
'devextreme-angular': 'npm:devextreme-angular@20.2.4',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>